<?php
namespace Teknisa\CMP\Modules\Cadastros\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\ParameterBag;
use Exception;

class PercentAjustmentController extends \Teknisa\GER\Controllers\TeknisaCrud 
{

    protected $crudService;
	protected $newCode;
	protected $dataSourceName;
	protected $environment;
	
    public function __construct($crudService,  ParameterBag $parameterBag, $environment, $newCode) 
    {
        $this->crudService = $crudService;
        $this->parameterBag = $parameterBag;
        $this->newCode = $newCode;
        $this->environment = $environment;
    }

    public function updatePercentAdjustments(DTO\Request $request, DTO\Response $response)
    {
        $row = $request->getRow();
        
        $row['VRPERCENTDESCONTO']  = self::strToFloat($row['VRPERCENTDESCONTO']);
        $row['VRPERCENTACRESCIMO'] = self::strToFloat($row['VRPERCENTACRESCIMO']);
        
        $row['VRPERCENTDESCONTO_inline']  = self::strToFloat($row['VRPERCENTDESCONTO_inline']);
        $row['VRPERCENTACRESCIMO_inline'] = self::strToFloat($row['VRPERCENTACRESCIMO_inline']);
        
        $requestSave = new DTO\Request\Row($row, $request->getMethod(), $request->getRoutePath(), $request->getUserId());
        
    	try {
            $this->dataSourceName = 'percentajusteitemaf';
            parent::save($requestSave, $response);
         
        } catch (\Exception $e) {
			$response->setError(new Error($e->getMessage(), 500));
        }
    }
    
    private function strToFloat($value)
    {
        if (gettype($value) == 'string') {
            $arrayReplace = array('R$', '.');
            $value = str_replace($arrayReplace, '', $value);
            $value = str_replace(',', '.', $value);
        }
        
        return (float) $value;
    }
    
    public function deletePercentAdjustments(DTO\Request $request, DTO\Response $response)
    {
        try {
            $this->dataSourceName = "percentajusteitemaf";
            parent::delete($request, $response);
            
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 1));
        }
    }
    
    public function addPercentAdjustments(DTO\Request $request, DTO\Response $response)
    {
        $row = $request->getRow();
        
        $row['NRPERCENTAJUSTEITEMAF'] = self::strToFloat($this->newCode->getCodeByTableName('PERCENTAJUSTEITEMAF', $this->environment->getNrOrg()));
        $row['VRPERCENTDESCONTO']  = self::strToFloat($row['VRPERCENTDESCONTO']);
        $row['VRPERCENTACRESCIMO'] = self::strToFloat($row['VRPERCENTACRESCIMO']);
        $row["__is_new"] = true;
        
        $requestSave = new DTO\Request\Row($row, $request->getMethod(), $request->getRoutePath(), $request->getUserId());
        
    	try {
            $this->dataSourceName = 'percentajusteitemaf';
            parent::save($requestSave, $response);
         
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }
}
